#pragma once

#include <boost/shared_ptr.hpp>

#include "DXUT.h"

#include "globals.h"
#include "dxhelpers.h"

namespace LPV {
	// only support 2d textures for now
	class ReadBackResult {
	public:
		friend ReadBackResult readBack( ID3D10Device *device, ID3D10Texture2D *texture, UINT mipSlice, UINT arraySlice );

		D3D10_MAPPED_TEXTURE2D map() {
			D3D10_MAPPED_TEXTURE2D mapInfo;

			HRESULT hr;
			V( texture->Map( 0, D3D10_MAP_READ, 0, &mapInfo ) );

			return mapInfo;
		}

		void unmap() {
			texture->Unmap( 0 );
		}

	protected:
		ReadBackResult( const boost::shared_ptr< ID3D10Texture2D > &texture ) : texture( texture ) {}

		boost::shared_ptr< ID3D10Texture2D > texture;
	};

	ReadBackResult readBack( ID3D10Device *device, ID3D10Texture2D *texture, UINT mipSlice, UINT arraySlice );
}